#include "StdAfx.h"
#include ".\nppackfile.h"
#include "NPUnzipFile.h"
#include "NPMemoryData.h"
#include "NPFileFactory.h"
#include <atlstr.h>

CNPPackFile::CNPPackFile(void)
{
	m_dwCurrRead = 0;
}

CNPPackFile::~CNPPackFile(void)
{
}
void CNPPackFile::AppendFileToPackURL(LPTSTR pszBuffer, int nMax, LPCTSTR pszcFile)
{
	CString strURL;
	strURL.Format(_T("%s?target=%s"), pszBuffer, pszcFile);
	_tcsncpy(pszBuffer, strURL, nMax);
}
BOOL CNPPackFile::Open( LPCTSTR lpszURL, DWORD dwFlags )
{
	BOOL bSuccess = FALSE;
	CString strURL = lpszURL;
	strURL.Replace(_T("pack:"), _T(""));

	int nFindIndex = strURL.Find(_T('?'));
	if ( nFindIndex <=0 )
	{
		return FALSE;
	}
	CString strZipPath = strURL.Left(nFindIndex);
	CString strParam = strURL.Right(strURL.GetLength()-nFindIndex-1);
	int nStart = 0;
	CString strKey = strParam.Tokenize(_T("="), nStart);
	CString strValue = strParam.Tokenize(_T("="), nStart);

	CNAutoBuffer<BYTE> ByteArrayPack;
	if (ReadBufferFromURL(ByteArrayPack, strZipPath) == FALSE)
	{
		return bSuccess;
	}

	CNPUnzipFile ZipFile;
	CNPMemoryData* pMemoryData = new CNPMemoryData(ByteArrayPack.GetBuffer(), ByteArrayPack.GetSize());
	ZipFile.Open(pMemoryData);

	USES_CONVERSION;
	if (ZipFile.FindFileInZip(CT2A(strValue)))
	{
		UnzipFileInfo fileInfo;

		//   о ´.
		int nResult = ZipFile.GetCurrentFileInfo(&fileInfo);

		LONG lFileSize = fileInfo.m_lUncompressedSize;
		BYTE* bufImage = m_BufFile.Alloc(lFileSize);
		ZipFile.OpenCurrentFile();

		DWORD dwIndex = 0;
		BYTE buffer[256];
		int size_read;
		do
		{		
			size_read = ZipFile.ReadCurrentFile(buffer, 256);
			CopyMemory(bufImage+dwIndex, buffer, size_read);
			dwIndex += size_read;
		}
		while (size_read>0);	

		ZipFile.CloseCurrentFile();
		bSuccess = TRUE;
	}

	ZipFile.Close();	
	delete pMemoryData;

	return bSuccess;
}
void CNPPackFile::Close()
{
	m_BufFile.Free();
}
DWORD CNPPackFile::Read( void* lpBuf, DWORD dwCount )
{
	DWORD dwRead = min(dwCount, m_BufFile.GetSize()-m_dwCurrRead);
	BYTE* pBuf = m_BufFile.GetBuffer();
	CopyMemory(lpBuf, pBuf+m_dwCurrRead, dwRead);
	return dwRead;
}
BOOL CNPPackFile::Write( const void* lpBuf, DWORD dwCount )
{
	ATLASSERT(FALSE);
	return FALSE;
}
ULONGLONG CNPPackFile::GetSize()
{
	return static_cast<ULONGLONG>(m_BufFile.GetSize());
}
BOOL CNPPackFile::ReadBufferFromURL(CNAutoBuffer<BYTE>& ByteArray, LPCTSTR pszcURL)
{
	BOOL bResult = FALSE;
	INPFile* pFile = CNPFileFactory::CreateFileObject(pszcURL);
	if (pFile)
	{
		if (pFile->Open(pszcURL, GENERIC_READ))
		{
			DWORD dwBufLen = static_cast<DWORD>(pFile->GetSize());
			BYTE* pBuf = ByteArray.Alloc(dwBufLen);
			if (pBuf)
			{
				DWORD dwReadLen = pFile->Read(pBuf, dwBufLen);
				ATLASSERT(dwReadLen == dwBufLen);

				bResult = TRUE;
			}
			else
			{
				ATLASSERT(FALSE);
				ATLTRACE(_T("Bytearray alloc error occur in Getlimitsize func\n"));

				bResult = FALSE;
			}
		}
		else
		{
			ATLTRACE(_T("NpFileFactory open fail occur in Getlimitsize func\n"));

			bResult = FALSE;
		}

		CNPFileFactory::DestroyFileObject(pFile);

		return bResult;
	}
	else
	{
		ATLASSERT(FALSE);
		ATLTRACE(_T("NpFileFactory create object error in Getlimitsize func\n"));

		return bResult;
	}
};